--[[
Textured sphere renderer, by retrotails.
]]--
function love.load()
    planet = {
        rot = 0,
        tex = love.graphics.newImage('earth.png'),
        canvas = love.graphics.newCanvas(256,256),
        shade = love.graphics.newImage('shade.png'),
        cd = 0,
        day = 0,
    }
    planet.w = planet.tex:getWidth()
    planet.h = planet.tex:getHeight()
    planet.w2 = planet.w/512
    planet.h2 = planet.h/512
    screen = {
        w = love.graphics.getWidth(),
        h = love.graphics.getHeight(),
    }
end
function love.update(dt2)
    dt = dt2
    if love.keyboard.isDown('escape') then
        love.event.quit()
    elseif love.keyboard.isDown('left') then
        planet.rot = planet.rot + dt * 128
        planet.cd = 2
    elseif love.keyboard.isDown('right') then
        planet.rot = planet.rot - dt * 128
        planet.cd = 2
    elseif love.keyboard.isDown('up') then
        planet.day = planet.day + .5 * dt
    elseif love.keyboard.isDown('down') then
        planet.day = planet.day - .5 * dt
    end
    if planet.cd <= 0 then
        planet.cd = 0
        planet.rot = planet.rot + dt * 64
    else
        planet.cd = planet.cd - dt
        if planet.cd <= 1 then
            planet.rot = planet.rot + (dt * 64) * (1 - planet.cd)
        end
    end
    if planet.rot >= 512 then
        planet.rot = planet.rot - 512
    elseif planet.rot <= 0 then
        planet.rot = planet.rot + 512
    end
    if planet.day > 3 then
        planet.day = planet.day - 4
    elseif planet.day < -1 then
        planet.day = planet.day + 4
    end
end
function love.draw()
    
    love.graphics.setCanvas(planet.canvas)
    for i = 0,screen.w - 1,1 do
        scale = math.cos((math.abs((i - 128)/128))^(math.pi/2))/(math.pi/2)
        love.graphics.setScissor(i, 0, 1, screen.h)
        love.graphics.draw(planet.tex, screen.w/2, screen.h/2, 0, scale/planet.h2, 1/planet.w2, planet.rot*(planet.w2) + planet.w/2, planet.h/2)
        love.graphics.draw(planet.tex, screen.w/2, screen.h/2, 0, scale/planet.h2, 1/planet.w2, planet.rot*(planet.w2) - planet.w/2, planet.h/2)
    end
    love.graphics.setCanvas()
    --Draws texture lixe its on a tube
    
    for i = 0,screen.h - 1,1 do
        scale = math.acos((math.abs((i - 128)/128))^2)/(math.pi/2)
        love.graphics.setScissor(screen.w * (1 - scale)/2,i,screen.w * (scale), 1)
        love.graphics.draw(planet.canvas, screen.w/2 - 1, screen.h/2, 0, scale, 1, 128, 128)
    end
    --Turns it into a sphere
    
    love.graphics.setColor(0,0,0,128)
    for i = 0,screen.h - 1,1 do
        scale = math.acos((math.abs((i - 128)/128))^2)/(math.pi/2)
        love.graphics.setScissor(screen.w * (1 - scale)/2,i,screen.w * (scale), 1)
        love.graphics.rectangle('fill', screen.w * (1 - scale * planet.day)/2, i, screen.w * (scale), 1)
    end
    love.graphics.setColor(255,255,255,255)
    love.graphics.setScissor()
    --Renders shadow
    
    love.graphics.setBlendMode('multiplicative')
    love.graphics.draw(planet.shade, 0, 0)
    love.graphics.setBlendMode('alpha')
    --Draws shadow thing. Cheats by using premade image.
    
    love.graphics.print(love.timer.getFPS(), 0, 0)
end